"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = createFarceStore;

var _Actions = _interopRequireDefault(require("farce/Actions"));

var _createHistoryEnhancer = _interopRequireDefault(require("farce/createHistoryEnhancer"));

var _queryMiddleware = _interopRequireDefault(require("farce/queryMiddleware"));

var _redux = require("redux");

var _Matcher = _interopRequireDefault(require("./Matcher"));

var _createMatchEnhancer = _interopRequireDefault(require("./createMatchEnhancer"));

var _foundReducer = _interopRequireDefault(require("./foundReducer"));

function createFarceStore({
  historyProtocol,
  historyMiddlewares,
  historyOptions,
  routeConfig
}) {
  const store = (0, _redux.createStore)((0, _redux.combineReducers)({
    found: _foundReducer.default
  }), (0, _redux.compose)((0, _createHistoryEnhancer.default)(Object.assign({}, historyOptions, {
    protocol: historyProtocol,
    middlewares: historyMiddlewares || [_queryMiddleware.default]
  })), (0, _createMatchEnhancer.default)(new _Matcher.default(routeConfig))));
  store.dispatch(_Actions.default.init());
  return store;
}

module.exports = exports.default;