import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
const _excluded = ["getFound"];
import { connect } from 'react-redux';
import ActionTypes from './ActionTypes';
import createBaseRouter from './createBaseRouter';

function resolveMatch(match) {
  return {
    type: ActionTypes.RESOLVE_MATCH,
    payload: match
  };
}

export default function createConnectedRouter(_ref) {
  let {
    getFound = ({
      found
    }) => found
  } = _ref,
      options = _objectWithoutPropertiesLoose(_ref, _excluded);

  return connect(state => {
    const {
      match,
      resolvedMatch
    } = getFound(state);
    return {
      match,
      resolvedMatch
    };
  }, {
    onResolveMatch: resolveMatch
  }, null, {
    // Don't block context propagation from above. The router should seldom
    // be unnecessarily rerendering anyway.
    pure: false,
    getDisplayName: () => 'ConnectedRouter'
  })(createBaseRouter(options));
}