import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
const _excluded = ["store", "historyProtocol", "historyMiddlewares", "historyOptions", "routeConfig"];
import FarceActions from 'farce/Actions';
import React from 'react';
import { Provider } from 'react-redux';
import createConnectedRouter from './createConnectedRouter';
import createFarceStore from './createFarceStore';
import { jsx as _jsx } from "react/jsx-runtime";
export default function createFarceRouter(_ref) {
  let {
    store,
    historyProtocol,
    historyMiddlewares,
    historyOptions,
    routeConfig
  } = _ref,
      options = _objectWithoutPropertiesLoose(_ref, _excluded);

  const ConnectedRouter = createConnectedRouter(options);

  class FarceRouter extends React.Component {
    constructor(props) {
      super(props);
      this.store = store || createFarceStore({
        historyProtocol,
        historyMiddlewares,
        historyOptions,
        routeConfig
      });
    }

    componentWillUnmount() {
      this.store.dispatch(FarceActions.dispose());
    }

    render() {
      return /*#__PURE__*/_jsx(Provider, {
        store: this.store,
        children: /*#__PURE__*/_jsx(ConnectedRouter, Object.assign({}, this.props))
      });
    }

  }

  return FarceRouter;
}